import React, {Component} from 'react';
import { View, TouchableOpacity, Image } from 'react-native';
import JitsiManager from '../lib/JitsiManager';
import { connect } from 'react-redux';
import data from '../actions';

class AudioButton extends Component{
    constructor(props){
        super(props);
        this.onMuteAudio = this.onMuteAudio.bind(this);
        this.onUnMuteAudio = this.onUnMuteAudio.bind(this);
    }

    onMuteAudio(){
        this.props.changeAudioState(true);
        this.props.onMuteAudio();
    }

    onUnMuteAudio(){
        this.props.changeAudioState(false);
        this.props.onUnMuteAudio();import React, {Component} from 'react';
        import { View, TouchableOpacity, Image } from 'react-native';
        import JitsiManager from '../lib/JitsiManager';
        import { connect } from 'react-redux';
        import data from '../actions';
        
        class AudioModeButton extends Component{
        
            constructor(props){
                super(props);
                this.onSetAudioToSpeaker = this.onSetAudioToSpeaker.bind(this);
                this.onSetAudioToEarpiece = this.onSetAudioToEarpiece.bind(this);
            }
        
            renderSpeakerIcon(){
                return <TouchableOpacity onPress={()=>this.onSetAudioToEarpiece()}><Image style={this.style.lt_control_icon} source={require('../icons/speaker_phone.png')}/></TouchableOpacity>;
            }
        
            renderEarPieceIcon(){
                return <TouchableOpacity onPress={()=>this.onSetAudioToSpeaker()}><Image style={this.style.lt_control_icon} source={require('../icons/icon_earpiece.png')}/></TouchableOpacity>;
            }
        
            render(){
                return(
                    <View style={this.style.lt_control_view}>
                        { this.props.audioSpeaker ? this.renderSpeakerIcon() : this.renderEarPieceIcon() }
                    </View>
                )
            }
        
            style = {
                lt_control_icon: { width: 25, height: 25 },
                lt_control_view: { width: 55, height: 55, margin: 5, backgroundColor: '#4d4c4f', borderRadius: 50, alignItems: 'center', justifyContent:'center' }
            };
        
            onSetAudioToEarpiece(){
                this.props.audioToSpeaker(false);
                this.props.onSetAudioToEarpiece();
            }
        
            onSetAudioToSpeaker(){
                this.props.audioToSpeaker(true);
                this.props.onSetAudioToSpeaker();
            }
        
        }
        function mapStateToProps (state) {
            return {
                audioSpeaker: state.tracks.audioSpeaker,
            }
        }
          
        function mapDispatchToProps (dispatch) {
            return {
                onSetAudioToEarpiece: () => JitsiManager.setAudioModeEarpiece(),
                onSetAudioToSpeaker: () => JitsiManager.setAudioModeSpeaker(),
                audioToSpeaker: (audio) => dispatch(data.changeAudioMode(audio)),
            }
        }
        
        export default connect(mapStateToProps, mapDispatchToProps)(AudioModeButton)
    }

    renderAudioMuteIcon(){
        return <TouchableOpacity onPress={()=>this.onUnMuteAudio()}><Image style={this.style.lt_control_icon} source={require('../icons/icon_audio_mute.png')}/></TouchableOpacity>;
    }

    renderAudioUnMuteIcon(){
        return <TouchableOpacity onPress={()=>this.onMuteAudio()}><Image style={this.style.lt_control_icon} source={require('../icons/icon_audio_unmute.png')}/></TouchableOpacity>;
    }

    render(){
        return(
            <View style={this.style.lt_control_view}>
                { this.props.audioMute ? this.renderAudioMuteIcon() : this.renderAudioUnMuteIcon() }
            </View>
        )
    }

    style = {
        lt_control_icon: { width: 25, height: 25 },
        lt_control_view: { width: 55, height: 55, margin: 5, backgroundColor: '#4d4c4f', borderRadius: 50, alignItems: 'center', justifyContent:'center' }
    };
}

function mapStateToProps (state) {
    return {
      audioMute: state.tracks.audioMute,
    }
}
  
function mapDispatchToProps (dispatch) {
    return {
        onMuteAudio: () => JitsiManager.onMuteAudio(),
        onUnMuteAudio: () => JitsiManager.onUnmuteAudio(),
        changeAudioState: (audio) => dispatch(data.changeAudioState(audio)),
    }
}

export default connect(mapStateToProps, mapDispatchToProps)(AudioButton)